xine-lib: xine-lib-1.2.13/src/demuxers/demux_slave.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions | Variables
demux_slave.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`

## Data Structures
struct | demux_slave_t

## Macros
#define | LOG_MODULE "demux_slave"
#define | LOG_VERBOSE
#define | SCRATCH_SIZE 1024
#define | CHECK_VPTS_INTERVAL 2*90000
#define | NETWORK_PREBUFFER 90000
#define | MAX_COMMAND_SIZE 20

## Functions
static int | demux_slave_next (demux_slave_t *this)
static int | demux_slave_send_chunk (demux_plugin_t *this_gen)
static int | demux_slave_get_status (demux_plugin_t *this_gen)
static void | demux_slave_send_headers (demux_plugin_t *this_gen)
static int | demux_slave_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static void | demux_slave_dispose (demux_plugin_t *this_gen)
static int | demux_slave_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_slave_get_capabilities (demux_plugin_t *this_gen)
static int | demux_slave_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
static void * | init_plugin (xine_t *xine, const void *data)

## Variables
static const demuxer_info_t | demux_info_slave
const plugin_info_t xine_plugin_info[] | EXPORTED

## Macro Definition Documentation

## ◆ CHECK_VPTS_INTERVAL

#define CHECK_VPTS_INTERVAL 2*90000

Referenced by demux_slave_next().

## ◆ LOG_MODULE

#define LOG_MODULE "demux_slave"

## ◆ LOG_VERBOSE

#define LOG_VERBOSE

## ◆ MAX_COMMAND_SIZE

#define MAX_COMMAND_SIZE 20

Referenced by demux_slave_next().

## ◆ NETWORK_PREBUFFER

#define NETWORK_PREBUFFER 90000

Referenced by demux_slave_next().

## ◆ SCRATCH_SIZE

#define SCRATCH_SIZE 1024

Referenced by demux_slave_next().

## Function Documentation

## ◆ demux_slave_dispose()

static void demux_slave_dispose | ( | demux_plugin_t * | this_gen | ) |
| static

References NULL, xine_list_delete(), and xine_list_next_value().

Referenced by open_plugin().

## ◆ demux_slave_get_capabilities()

static uint32_t demux_slave_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_slave_get_optional_data()

static int demux_slave_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_slave_get_status()

static int demux_slave_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_slave_get_stream_length()

static int demux_slave_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_slave_next()

static int demux_slave_next | ( | demux_slave_t * | this | ) |
| static

References _x_demux_control_newpts(), _x_demux_flush_engine(), BUF_CONTROL_NEWPTS, BUF_NUM_DEC_INFO, CHECK_VPTS_INTERVAL, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, buf_element_s::decoder_info_ptr, DEMUX_FINISHED, buf_element_s::disc_off, buf_element_s::free_buffer, input(), lprintf, MAX_COMMAND_SIZE, METRONOM_VPTS_OFFSET, NETWORK_PREBUFFER, buf_element_s::pts, SCRATCH_SIZE, buf_element_s::size, buf_element_s::type, type, xine_list_push_back(), XINE_VERBOSITY_LOG, and xprintf.

Referenced by demux_slave_send_chunk().

## ◆ demux_slave_seek()

static int demux_slave_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

Referenced by open_plugin().

## ◆ demux_slave_send_chunk()

static int demux_slave_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References demux_slave_next().

Referenced by open_plugin().

## ◆ demux_slave_send_headers()

static void demux_slave_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), DEMUX_OK, XINE_STREAM_INFO_HAS_AUDIO, and XINE_STREAM_INFO_HAS_VIDEO.

Referenced by open_plugin().

## ◆ init_plugin()

static void * init_plugin | ( | xine_t * | xine,
|  | const void * | data )
| static

References demux_plugin_s::dispose, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References _x_demux_read_header(), xine_stream_s::content_detection_method, DEMUX_FINISHED, demux_slave_dispose(), demux_slave_get_capabilities(), demux_slave_get_optional_data(), demux_slave_get_status(), demux_slave_get_stream_length(), demux_slave_seek(), demux_slave_send_chunk(), demux_slave_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, and xine_list_new().

Referenced by init_plugin().

## Variable Documentation

## ◆ demux_info_slave

const demuxer_info_t demux_info_slave
| static

Initial value:
= {
.priority = 10,
}

## ◆ EXPORTED

const plugin_info_t xine_plugin_info [] EXPORTED

Initial value:
= {
{ PLUGIN_DEMUX, 27, "slave", XINE_VERSION_CODE, &demux_info_slave, init_plugin },
{ PLUGIN_NONE, 0, NULL, 0, NULL, NULL }
}
init_plugin
static void * init_plugin(xine_t *xine, const void *data)
Definition demux_slave.c:394
demux_info_slave
static const demuxer_info_t demux_info_slave
Definition demux_slave.c:414
XINE_VERSION_CODE
#define XINE_VERSION_CODE
Definition xine_internal.h:57
NULL
NULL
Definition xine_plugin.c:78
PLUGIN_DEMUX
#define PLUGIN_DEMUX
Definition xine_plugin.h:31
PLUGIN_NONE
#define PLUGIN_NONE
Definition xine_plugin.h:29